; 
    include \masm32\include\masm32rt.inc
    .586 

    IdleThread  PROTO
    CtrlHandler PROTO :DWORD
; 
    .data
        threadID    dd 0
        hThread     dd 0
        hTimer      dd 0
        exitFlag    dd 0
        loopCount   dd 0
        ctrlCount   dd 0
        idleCount   dd 0
        temp        dd 0
        exitCode    dd 0
        src db 'This is the source string to copy',0
        align 4
        dst db $-src dup(0)
        align 4
    .code
; 
start:
; 

    ;invoke GetCurrentProcess
    ;invoke SetPriorityClass, eax, HIGH_PRIORITY_CLASS

    invoke CreateThread,NULL,0,ADDR IdleThread,
        NULL,CREATE_SUSPENDED,ADDR threadID
    mov hThread,eax

    invoke SetThreadPriority,hThread,THREAD_PRIORITY_IDLE

    invoke SetConsoleCtrlHandler,ADDR CtrlHandler,TRUE
    
    invoke CreateWaitableTimer,NULL,FALSE,NULL
    mov hTimer, eax

    ; ---------------------------------------------------
    ; ADDR temp used here because 0 will not work, even ?
    ; though the due time is apparently ignored when a  ?
    ; timer period (here set to 1000 ms) is specified.  ?
    ; ---------------------------------------------------

    invoke SetWaitableTimer,hTimer,ADDR temp,1000,NULL,NULL,0

    mov eax,input("Press Ctrl-C to exit, Ctrl-break to test, enter to begin")
    print chr$("Testing szCopy with timer and control handler",13,10)

    invoke ResumeThread,hThread

    mov esi,12345678h

    .WHILE (esi == 12345678h && exitFlag == FALSE)

        mov ebx,100000
    @@: invoke szCopy,ADDR src,ADDR dst
        sub ebx,1
        jnz @b

        invoke WaitForSingleObject,hTimer,1000

        print chr$("loopCount = ")
        mov eax,loopCount
        print ustr$(eax)
        print chr$(", idleCount = ")
        mov eax,idleCount
        print ustr$(eax)
        print chr$(", ctrlCount = ")
        mov eax,ctrlCount
        print ustr$(eax)
        print chr$(13,10)

        inc loopCount

    .ENDW

    ; exit loop after Cntrl-C or if the content of esi is destroyed

    .IF (esi != 12345678h)
        print chr$("error: esi should be 12345678 instead of ")
        print uhex$(esi),13,10
    .ENDIF

    invoke SetThreadPriority,hThread,THREAD_PRIORITY_HIGHEST

    .WHILE (exitCode == STILL_ACTIVE)
        invoke GetExitCodeThread,hThread,ADDR exitCode
    .ENDW

    invoke CloseHandle,hThread

    exit

; 

CtrlHandler proc ctrlType:DWORD

    .IF (ctrlType == CTRL_BREAK_EVENT)

       inc ctrlCount

    .ELSE ; probably ^C, Close, Logout, or ShutDown

       inc exitFlag

    .ENDIF

    mov eax,TRUE
    ret

CtrlHandler endp

; 

IdleThread proc uses ebx

    .WHILE (exitFlag == 0)

        inc idleCount

        invoke Sleep,1000       ; sync with main loop

    .ENDW

    ret

IdleThread endp

; 
end start
